Unit SFA6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure SFA6R(N :Integer; X :Real; var H1 :Real; var H2 :Real);

implementation

procedure SFA6R(N :Integer; X :Real; var H1 :Real; var H2 :Real);
var
I :Integer;
C,K,P,R,A,S,T,D,B,C1 :Real;
const
ZERO :Real = 0.0;
TWO :Real = 2.0;
ONE :Real = 1.0;
SYS039 :Real = 0.57721566490153286060651200000;
SYS053 :Real = 3.4E38;
SYS013 :Real = 0.31830988618379067153776752674503;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100;
begin
if ( X <> ZERO ) 
 then goto _20;
H2 := -SYS053;
if ( N <> 0 ) 
 then goto _10;
H1 := ONE;
goto _100;
_10:
H1 := ZERO;
goto _100;
_20:
A := ONE;
C := TWO*SYS039;
R := ONE;
H1 := ZERO;
H2 := ZERO;
S := ZERO;
if ( N = 0 ) 
 then goto _40;
for I:=1 to N do
 begin
  R := R*I;
  S := S+ONE/I;
_30:
 end;
_40:
if ( N <> 0 ) 
 then goto _50;
D := ZERO;
goto _60;
_50:
D := R/N;
_60:
R := ONE/R;
K := X*X/4;
P := IntPower(K,N);
T := Ln(K)+C;
I := -1;
_70:
I := I+1;
B := H2;
H1 := H1+A*R;
if ( I >= N ) 
 then goto _80;
C1 := D/P;
goto _90;
_80:
C1 := ZERO;
_90:
H2 := H2+A*(R*(T-S)-C1);
A := A*K/(I+1);
R := -R/(I+N+1);
S := S+ONE/(I+1)+ONE/(I+N+1);
if ( I+1 < N ) 
 then D := D/(N-I-1);
if ( I <= N ) or ( B <> H2 ) 
 then goto _70;
P := IntPower(X/TWO,N);
H1 := H1*P;
H2 := SYS013*H2*P;
_100:
end;

end.
